/**
 * @(#)pms4_5.cpp 2000/04/03
 *
 * @author Tognon Stefano
 * @version 1.00
 *
 * This program automatically search all combination for prime magic square
 * of order 4 from prime 5.
 * The square is printed in standard output, while the other information are
 * printed in standard error.
 *
 * note: some comments are in the style of Javadoc of Java language!
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307  USA.
 */

typedef unsigned int word;

const int ORDER=4;        // square order
const int OR2=ORDER*ORDER;
const word MAGIC=124;     // magic constant

// number of max spaces between output values
const int MAX_BLANK=3;

// list of sequential primes numbers
const word PRIME[ORDER*ORDER]={
          5,    7,   11,   13,   17,   19,   23,   29,   31,
         37,   41,   43,   47,   53,   59,   61};

#define A1 for (int a1=0; a1<OR2; a1++)
#define A2 for (int a2=a1+1; a2<OR2; a2++)
#define A3 for (int a3=a2+1; a3<OR2; a3++)
#define A4 for (int a4=a3+1; a4<OR2; a4++)

#define FOR A1 A2 A3 A4

#define CP(a) PRIME[a]

#define VAL CP(a1)+CP(a2)+CP(a3)+CP(a4)

#define SEQ CP(a1)<<' '<<CP(a2)<<' '<<CP(a3)<<' '<<CP(a4)
